%{
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "path_types.h"
#include "path_parser.tab.h"
%}
%option noyywrap

%%

[ \t\n\r,] ;
[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)? { /*printf("matched %s\n", yytext);*/ yylval.num = atof(yytext); return NUM; }

M    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = ABSOLUTE; return MOVE; }
m    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = RELATIVE; return MOVE; }
L    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = ABSOLUTE; return LINE; }
l    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = RELATIVE; return LINE; }
H    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = ABSOLUTE; return HLINE; }
h    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = RELATIVE; return HLINE; }
V    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = ABSOLUTE; return VLINE; }
v    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = RELATIVE; return VLINE; }
C    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = ABSOLUTE; return CUBIC_CURVE; }
c    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = RELATIVE; return CUBIC_CURVE; }
S    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = ABSOLUTE; return SMOOTH_CUBIC_CURVE; }
s    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = RELATIVE; return SMOOTH_CUBIC_CURVE; }
Q    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = ABSOLUTE; return QUAD_CURVE; }
q    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = RELATIVE; return QUAD_CURVE; }
T    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = ABSOLUTE; return SMOOTH_QUAD_CURVE; }
t    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = RELATIVE; return SMOOTH_QUAD_CURVE; }
A    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = ABSOLUTE; return ARC; }
a    { /*printf("matched %s\n", yytext);*/ yylval.abs_or_rel = RELATIVE; return ARC; }
[Zz] { /*printf("matched %s\n", yytext);*/ return CLOSE_PATH; }

%%

/*C code for lexer*/
