#ifndef _PATH_TYPES_H_
#define _PATH_TYPES_H_

typedef enum {ABSOLUTE, RELATIVE} abs_or_rel_t;

typedef enum {
  MOVE_CMD,
  LINE_CMD,
  HLINE_CMD,
  VLINE_CMD,
  CUBIC_CURVE_CMD,
  SMOOTH_CUBIC_CURVE_CMD,
  QUAD_CURVE_CMD,
  SMOOTH_QUAD_CURVE_CMD,
  ARC_CMD,
  CLOSE_PATH_CMD
} cmd_type_t;

typedef struct {
  float x1;
  float y1;
  float x2;
  float y2;
} control_point_t;

typedef struct {
  float rx;
  float ry;
  float x_axis_rotation;
  int flags;
} arc_data_t;

typedef struct command_t {
  cmd_type_t type;
  abs_or_rel_t abs_or_rel;
  float x0;
  float y0;
  union {
    control_point_t control_point_data;
    arc_data_t arc_data;
  };
  float x;
  float y;
  struct command_t* next;
} command_t;

typedef struct command_list_t {
  command_t* head;
  command_t* tail;
  struct command_list_t* next;
} command_list_t;

typedef struct {
  command_list_t* head;
  command_list_t* tail;
} command_list_list_t;

typedef struct {
  command_list_list_t* cmds;
  float size;
} path_t;

#endif
